<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="auto"
      v-loading="formLoading"
      class="energy-device-reset-dialog-form"
    >
      <el-form-item :label="t('EnergyManagement.EnergyDevice.dialogNameLabel')" prop="name">
        <el-input disabled v-model="formData.name" :placeholder="t('EnergyManagement.EnergyDevice.dialogNamePlaceholder')" />
      </el-form-item>
      <el-form-item :label="t('EnergyManagement.EnergyDevice.dialogCodeLabel')" prop="code">
        <el-input disabled v-model="formData.code" :placeholder="t('EnergyManagement.EnergyDevice.dialogCodePlaceholder')" />
      </el-form-item>
      <el-col :span="12">
        <el-form-item :label="t('EnergyManagement.EnergyDeviceCheck.dialogLastCheckTimeLabel')" prop="lastCheckTime">
          <el-date-picker
            v-model="formData.lastCheckTime"
            type="date"
            value-format="x"
            :placeholder="t('EnergyManagement.EnergyDeviceCheck.dialogLastCheckTimePlaceholder')"
          />
        </el-form-item>
      </el-col>
      <el-form-item :label="t('EnergyManagement.EnergyDeviceCheck.dialogLastCheckValueLabel')" prop="lastCheckValue">
        <el-input v-model="formData.lastCheckValue" :placeholder="t('EnergyManagement.EnergyDeviceCheck.dialogLastCheckValuePlaceholder')" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">{{ t('EnergyManagement.EnergyDeviceCheck.dialogOkButtonText') }}</el-button>
      <el-button @click="dialogVisible = false">{{ t('EnergyManagement.EnergyDeviceCheck.dialogCancelButtonText') }}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getStrDictOptions, DICT_TYPE } from '@/utils/dict'
import { EnergyDeviceApi, EnergyDeviceVO } from '@/api/mes/energydevice'

/** 能源设备 表单 */
defineOptions({ name: 'EnergyDeviceForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  name: undefined,
  code: undefined,
  deviceType: undefined,
  info: undefined,
  checkCron: undefined,
  lastCheckTime: undefined,
  lastCheckValue: undefined,
  unitName: undefined,
  isEnable: undefined
})
const formRules = reactive({
  isEnable: [{ required: true, message: t('EnergyManagement.EnergyDevice.validatorIsEnableRequired'), trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('EnergyManagement.EnergyDeviceCheck.dialogLastCheckValueLabel')
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await EnergyDeviceApi.getEnergyDevice(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as EnergyDeviceVO
    if (formType.value === 'create') {
      await EnergyDeviceApi.createEnergyDevice(data)
      message.success(t('common.createSuccess'))
    } else {
      await EnergyDeviceApi.updateEnergyDevice(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    name: undefined,
    code: undefined,
    deviceType: undefined,
    info: undefined,
    checkCron: undefined,
    lastCheckTime: undefined,
    lastCheckValue: undefined,
    unitName: undefined,
    isEnable: undefined
  }
  formRef.value?.resetFields()
}
</script>
